SystemOrganization addCategory: #'Orca-Tools'!
SystemOrganization addCategory: #'Orca-Tools-Tests'!

Morph subclass: #OrcaCompilingNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools'!

OrcaCompilingNotification class
	instanceVariableNames: 'singleton'!

OrcaCompilingNotification class
	instanceVariableNames: 'singleton'!

OrcaCompilingNotification subclass: #OrcaAnimatedCompilingNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools'!

!OrcaAnimatedCompilingNotification class methodsFor: 'configuration' stamp: 'hk 4/19/2011 10:33'!
pathOfDefaultImage

	^ (Smalltalk at: #OrcaFileRootDirectory) pathName,
	FileDirectory slash, 'images', FileDirectory slash, 'loader.gif'! !

!OrcaAnimatedCompilingNotification methodsFor: 'initialization' stamp: 'sw 4/26/2011 11:28'!
addMorphs

	super addMorphs.
	(Smalltalk globals includesKey: #OrcaFileRootDirectory) 
		ifTrue: [ self addMorph: self createSpinner ]! !

!OrcaAnimatedCompilingNotification methodsFor: 'initialization' stamp: 'hk 4/19/2011 10:43'!
createSpinner

	^ (AnimatedImageMorph fromGIFFileNamed: self class pathOfDefaultImage) position: 70 @ 25! !

!OrcaCompilingNotification class methodsFor: 'configuration' stamp: 'hk 4/19/2011 10:24'!
defaultFont

	^ TextFontReference toFont: (StrikeFont familyName: #ComicBold size: 31)! !

!OrcaCompilingNotification class methodsFor: 'configuration' stamp: 'hk 4/19/2011 10:25'!
text

	^ 'Orca is compiling...' asText! !

!OrcaCompilingNotification methodsFor: 'initialization' stamp: 'hk 4/19/2011 10:27'!
addMorphs

	self addMorph: self createText.! !

!OrcaCompilingNotification methodsFor: 'initialization' stamp: 'hk 4/19/2011 10:41'!
createText

	^ TextMorph new
		contents: (self class text addAttribute: self class defaultFont);
		yourself! !

!OrcaCompilingNotification methodsFor: 'initialization' stamp: 'hk 4/19/2011 10:27'!
initialize 
	
	super initialize.
	self
		setProperties;
		addMorphs;
		openInWorld;
		hide.! !

!OrcaCompilingNotification methodsFor: 'initialization' stamp: 'hk 4/19/2011 10:38'!
setProperties
	
	self
		color: Color white;
		extent: 170 @ 68! !

Model subclass: #OrcaControlPanel
	instanceVariableNames: 'compilingNotification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools'!

OrcaControlPanel class
	instanceVariableNames: 'instance'!

!OrcaControlPanel commentStamp: 'sw 4/14/2011 10:38' prior: 0!
I am a configuration panel for the Orca Webframework.

I can set swazooDebug ->  Smalltalk at: #OrcaDebugSwazooInternalErrors

Default: the print messages are disabled.
in Smalltalk -> see updatesKey.

OrcaTranslatedClass disablePrintUpdates 
OrcaTranslatedMethod disablePrintUpdates 


entweder cacheCodeFor:  producedBy: 
	speicher state
	set on
	work
	reset state
	
oder in codeForClasses: 

precompile postcompile block -> setzt flag auf controlpanel (und zeigt notification an)!

OrcaControlPanel class
	instanceVariableNames: 'instance'!

!OrcaControlPanel class methodsFor: 'open' stamp: 'hk 4/18/2011 15:01'!
close

	self instance delete.! !

!OrcaControlPanel class methodsFor: 'configuration' stamp: 'hk 4/19/2011 11:53'!
defaultPosition

	^ 100 @ 100! !

!OrcaControlPanel class methodsFor: 'accessing' stamp: 'sw 4/14/2011 11:43'!
instance
	instance isNil ifTrue: [
		self instance: (ToolBuilder build: self)].
	^ instance! !

!OrcaControlPanel class methodsFor: 'accessing' stamp: 'sw 4/14/2011 11:39'!
instance: anObject
	instance := anObject! !

!OrcaControlPanel class methodsFor: 'open' stamp: 'hk 4/19/2011 11:53'!
open

	^ self instance openAsIs position: self defaultPosition! !

!OrcaControlPanel class methodsFor: 'open' stamp: 'hk 4/18/2011 15:01'!
reset

	self close.
	self instance: nil.! !

!OrcaControlPanel class methodsFor: 'configuration' stamp: 'sw 4/14/2011 10:25'!
sizeOfCheckBoxes

	^ self sizeOfCheckBoxesWidth @ self sizeOfCheckBoxesHeight ! !

!OrcaControlPanel class methodsFor: 'configuration' stamp: 'sw 4/14/2011 10:24'!
sizeOfCheckBoxesHeight

	^ 0.08! !

!OrcaControlPanel class methodsFor: 'configuration' stamp: 'sw 4/14/2011 10:24'!
sizeOfCheckBoxesWidth

	^ 0.8! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 09:57'!
buildButtonPanelWith: builder

	| horizontalPanel |
	horizontalPanel := builder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		frame: (0.0 @ 0.8 extent: 1 @ 0.2);
		children: OrderedCollection new.
	
	horizontalPanel children
		add: (self buildClearCacheButtonWith: builder);
		add: (self buildRestartButtonWith: builder).
	
	^ horizontalPanel! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 12:02'!
buildChooseDirectoryButtonWith: builder

	^ builder pluggableButtonSpec new
		model: self;
		label: 'Choose directory';
		color: #runButtonColor;
		action: #chooseRootdirectory;
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 09:54'!
buildClearCacheButtonWith: builder

	^ builder pluggableButtonSpec new
		model: self;
		label: 'Clear cache';
		color: #runButtonColor;
		action: #clearCache;
		frame: (0.1 @ 0.9 extent: 0.25 @ 0.1);
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 11:10'!
buildCompilingCheckBoxWith: builder

	^ builder pluggableCheckBoxSpec new
		model: self;
		label: #labelShowCompilingNotification;
		state: #shouldShowCompilingNotification;
		action: #changeShowCompilingNotification;
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 11:11'!
buildDebugCheckBoxWith: builder

	^ builder pluggableCheckBoxSpec new
		model: self;
		label: #labelDebugSwazooMessages;
		state: #shouldDebugSwazooMessages;
		action: #changeDebugSwazooMessages;
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 10:01'!
buildDirectoryGroupWith: builder

	| panelSpec |
	panelSpec := self buildDirectoryPanelWith: builder.
	
	panelSpec children
		add: (self buildFileInputWith: builder);
		add: (self buildChooseDirectoryButtonWith: builder).
		
	^ panelSpec! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 09:47'!
buildDirectoryPanelWith: builder

	^ builder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		children: OrderedCollection new;
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 09:43'!
buildFileInputWith: builder

	^ builder pluggableInputFieldSpec new
		model: self;
		getText: #currentRootDirectory;
		name: #rootdirectory;
		setText: #setCurrentRootDir:notifying:;
		selection: #selection;
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'ag 4/27/2011 09:49'!
buildRestartButtonWith: builder

	^ builder pluggableButtonSpec new
		model: self;
		label: 'Forced restart';
		color: #runButtonColor;
		action: #hardRestart;
		frame: (0.4 @ 0.9 extent: 0.25 @ 0.1);
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 10:15'!
buildVerticalGroupWith: builder

	| verticalPanel |
	verticalPanel := self buildVerticalPanelWith: builder.
	
	verticalPanel children
		add: (self buildDebugCheckBoxWith: builder);
		add: (self buildCompilingCheckBoxWith: builder);
		add: (self buildDirectoryGroupWith: builder).
		
	^ verticalPanel! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 09:41'!
buildVerticalPanelWith: builder

	^ builder pluggablePanelSpec new
		model: self;
		layout: #vertical;
		frame: (0.0 @ 0 extent: 1 @0.4 );
		children: OrderedCollection new;
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 09:40'!
buildWindowWith: builder

	^ builder pluggableWindowSpec new
		model: self;
		extent: 180@200;
		label: self class name asString;
		children: OrderedCollection new;
		yourself! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 11:02'!
buildWith: builder

	| windowSpec window |
	windowSpec := self buildWindowWith: builder.
	windowSpec children
		add: (self buildVerticalGroupWith: builder);
		add: (self buildButtonPanelWith: builder).

	window := (builder build: windowSpec)
		position: 0@0;
		addMorph: (self initializeCompilingNotification).
	self setMorphColorsOf: window submorphs.
	
	^ window! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/12/2011 15:42'!
changeDebugSwazooMessages

	Smalltalk at: #OrcaDebugSwazooInternalErrors put:
		((Smalltalk at: #OrcaDebugSwazooInternalErrors ifAbsent: [false ]) not)! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'hk 4/19/2011 11:10'!
changeShowCompilingNotification
	
	self shouldShowCompilingNotification
		ifTrue: [ self disableCompilingNotfication ]
		ifFalse: [ self enableCompilingNotfication ].
	self changed: ( self shouldShowCompilingNotification ).! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 11:30'!
checkboxColor

	^ Color white! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'ag 4/26/2011 09:22'!
chooseRootdirectory
	
	| chooser directory |
	chooser := FileChooser new.
	directory := chooser
		initializeAsSystemWindow;
		setDirectory: OrcaFileRequestHandler defaultRootDirectory;
		open;
		directory.
	OrcaFileRequestHandler defaultRootDirectory: directory pathName.
	self changed: #currentRootDirectory.! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'ag 4/27/2011 10:06'!
clearCache

	OrcaClassesHandler clearCache.! !

!OrcaControlPanel methodsFor: 'accessing' stamp: 'sw 4/14/2011 12:53'!
compilingNotification
	^ compilingNotification! !

!OrcaControlPanel methodsFor: 'accessing' stamp: 'sw 4/14/2011 12:53'!
compilingNotification: anObject
	compilingNotification := anObject! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 14:18'!
currentRootDirectory

	| rootdirectory |
	
	rootdirectory := Smalltalk at: #OrcaFileRootDirectory  ifAbsent: [  ^ ''].
	^ rootdirectory pathName! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/14/2011 14:30'!
disableCompilingNotfication 

	OrcaTranslatedClasses stopCallingOnUpdates: self class! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/26/2011 11:44'!
enableCompilingNotfication
	
	self initializeCompilingNotification.
	OrcaTranslatedClasses callOnUpdateStart: [ :class :message | self compilingNotification show ] withId: self class.
	OrcaTranslatedClasses callOnUpdateStop: [ :class :message | self compilingNotification hide ] withId: self class.! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'ag 4/27/2011 09:49'!
hardRestart

	OrcaDispatcher hardRestart.! !

!OrcaControlPanel methodsFor: 'build' stamp: 'hk 4/19/2011 10:47'!
initializeCompilingNotification

	self compilingNotification: (OrcaAnimatedCompilingNotification new position: 5@96).
	^ self compilingNotification! !

!OrcaControlPanel methodsFor: 'defaults' stamp: 'sw 4/12/2011 15:43'!
labelDebugSwazooMessages

	 ^ 'Show debug Swazoo Messages'! !

!OrcaControlPanel methodsFor: 'defaults' stamp: 'sw 4/12/2011 16:50'!
labelShowCompilingNotification

	 ^ 'Show Compiling Notification'! !

!OrcaControlPanel methodsFor: 'defaults' stamp: 'sw 4/14/2011 11:30'!
runButtonColor
	
	^ Color white! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 13:52'!
selection
	"just copied - don't know for what it is needed"

	^ 1 to: 0  "null selection"! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/26/2011 11:45'!
setCurrentRootDir: input notifying: aController
	
	OrcaFileRequestHandler defaultRootDirectory: input asString.
	self changed: #currentRootDirectory.
	self initializeCompilingNotification.
	^ true! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 11:34'!
setMorphColorsOf: aCollection
	"Because of a bug during building a checkbox, we need to set the color manually."
	
	aCollection do: [ :each |
		(each class == PluggableCheckBoxMorph) ifTrue: [ each color: self checkboxColor ].
		self setMorphColorsOf: each submorphs.
	].! !

!OrcaControlPanel methodsFor: 'testing' stamp: 'hk 4/19/2011 11:11'!
shouldDebugSwazooMessages

	^ Smalltalk
		at: #OrcaDebugSwazooInternalErrors
		ifAbsent: [ false ]! !

!OrcaControlPanel methodsFor: 'testing' stamp: 'hk 4/19/2011 11:10'!
shouldShowCompilingNotification

	^ OrcaTranslatedClasses globalDictionaryIncludes: self class
	! !

TestCase subclass: #OrcaControlPanelTest
	instanceVariableNames: 'panel originalStateOfDebugSwazooMessages originalStateOfShowCompilingNotification originalCodeFactoryInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools-Tests'!

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:45'!
model
	
	^ self panel model! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'ag 4/27/2011 10:11'!
originalCodeFactoryInstance
	^ originalCodeFactoryInstance! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'ag 4/27/2011 10:11'!
originalCodeFactoryInstance: anObject
	originalCodeFactoryInstance := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:46'!
originalStateOfDebugSwazooMessages
	^ originalStateOfDebugSwazooMessages! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:46'!
originalStateOfDebugSwazooMessages: anObject
	originalStateOfDebugSwazooMessages := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:59'!
originalStateOfShowCompilingNotification
	^ originalStateOfShowCompilingNotification! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:59'!
originalStateOfShowCompilingNotification: anObject
	originalStateOfShowCompilingNotification := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 14:19'!
panel
	^ panel! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 14:19'!
panel: anObject
	panel := anObject! !

!OrcaControlPanelTest methodsFor: 'running' stamp: 'ag 4/27/2011 10:13'!
setUp 

	self panel: (OrcaControlPanel reset; open).
	self originalStateOfDebugSwazooMessages: OrcaControlPanel instance model shouldDebugSwazooMessages.
	Smalltalk removeKey: #OrcaDebugSwazooInternalErrors ifAbsent: [].
	self originalStateOfShowCompilingNotification: OrcaControlPanel instance model shouldShowCompilingNotification.
	Smalltalk removeKey: #OrcaShowCompilingNotification ifAbsent: [].
	
	self originalCodeFactoryInstance: OrcaClassesHandler codeFactoryInstance.
	OrcaClassesHandler codeFactoryInstance: OrcaPrettyCodeFactory new.! !

!OrcaControlPanelTest methodsFor: 'running' stamp: 'ag 4/27/2011 10:10'!
tearDown
	
	self panel delete.
	Smalltalk at: #OrcaDebugSwazooInternalErrors put: self originalStateOfDebugSwazooMessages.
	Smalltalk at: #OrcaShowCompilingNotification put: self originalStateOfShowCompilingNotification.
	
	OrcaClassesHandler codeFactoryInstance: self originalCodeFactoryInstance.! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'hk 4/19/2011 10:51'!
testBuildSystemWindow

	self assert: (self panel class == PluggableSystemWindow).! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'ag 4/27/2011 10:08'!
testClearCache

	self model clearCache.
	self assert: OrcaClassesHandler codeFactoryInstance codeCache isEmpty.! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'hk 4/19/2011 11:47'!
testToggleShouldDebugSwazooMessages

	| oldState |
	oldState := self model shouldDebugSwazooMessages.
	self model changeDebugSwazooMessages.
	self deny: (oldState == self model shouldDebugSwazooMessages).
	
	
	! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'hk 4/19/2011 11:50'!
testToggleShouldShowCompilingNotification

	| oldState |
	oldState := self model shouldShowCompilingNotification.
	self model changeShowCompilingNotification.
	
	self deny: (oldState == self model shouldShowCompilingNotification).
	
	
	! !
